/**
 * Manage the transition between pages
 */
jsp.manager = (function(){
    var duneapi,
        contentViewDiv,
        contentViews = {},
        current;

    function init(){
        duneapi = jsp.byId("duneapi");
        contentViewDiv = jsp.byId("main");
        jsp.stat = new TnsVideoStatistic();

        jsp.api.loadData({callbackSuccess: function() {
            document.body.classList.remove("start-load");
            showView();
            jsp.api.imagePreload();
        }});
    }

    function keyListener(e){
        var code = e.keyCode,
            exitKey = jsp.keyCode[jsp.api.getExitPluginKey()];

        switch (code) {
            case exitKey: exitPlugin(); break;
            case jsp.keyCode.dune: reload(); e.preventDefault(); break;
            case jsp.keyCode.return: prevPage(); e.preventDefault(); break;
            default: defaultHandler(code); break;
        }
    }

    window.addEventListener("load", init);
    window.addEventListener(jsp.DEFAULT_KEY_EVENT, keyListener);

    function exitPlugin(){
        duneapi.exitBrowser(duneapi.EXIT_BROWSER_MODE_CLOSE);
    }

    function reload(){
        location.reload(true);
    }

    function defaultHandler(code) {

    }

    function createView(className){
        jsp.views[className].prototype.name = className;
        var obj = new jsp.views[className]();
        obj.bind();
        return obj;
    }

    function refreshView(className){
        if (!contentViews[className]) {
            contentViews[className] = createView(className);
        }
    }

    function showViewContent(view){
        contentViewDiv.innerHTML = "";
        contentViewDiv.appendChild(view.viewDiv);
    }

    function showView(){
        var url = location.hash.replace("#", "") || "video/" + jsp.api.getPlayingChannelId(),
            params = jsp.uriToArr(url),
            viewName = params.shift();

        refreshView(viewName);

        current && current.destroy();
        current = contentViews[viewName];
        showViewContent(current);
        current.render.apply(current, params);
    }

    window.addEventListener("hashchange", showView);

	return {
        isViewVisible : function(view) {
            return view === current;
        },

        log: function(message) {
            duneapi.log(message.toString());
        }
    }
})();